/* aer7d.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int aer7d_c(integer *nm, integer *n, doublereal *ar,
        doublereal *ai, doublereal *d__, doublereal *e, doublereal *e2, 
        doublereal *tau)
{
    /* System generated locals */
    integer ar_dim1, ar_offset, ai_dim1, ai_offset, i__1, i__2, i__3;
    doublereal d__1, d__2;
    doublecomplex z__1;

    /* Builtin functions */
    double sqrt(doublereal), z_abs(doublecomplex *);

    /* Local variables */
    static doublereal f, g, h__;
    static integer i__, j, k, l;
    static doublereal scale, fi, gi, hh;
    static integer ii;
    static doublereal si;
    static integer jp1;


#define ai_subscr(a_1,a_2) (a_2)*ai_dim1 + a_1
#define ai_ref(a_1,a_2) ai[(a_2)*ai_dim1 + a_1]
#define ar_subscr(a_1,a_2) (a_2)*ar_dim1 + a_1
#define ar_ref(a_1,a_2) ar[(a_2)*ar_dim1 + a_1]
#define tau_ref(a_1,a_2) tau[(a_2)*2 + a_1]

    /* Parameter adjustments */
    tau -= 3;
    --e2;
    --e;
    --d__;
    ai_dim1 = *nm;
    ai_offset = ai_dim1 + 1;
    ai -= ai_offset;
    ar_dim1 = *nm;
    ar_offset = ar_dim1 + 1;
    ar -= ar_offset;

    /* Function Body */
    tau_ref(1, *n) = 1.;
    tau_ref(2, *n) = 0.;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L1: */
        d__[i__] = ar_ref(i__, i__);
    }
/* ********** */
    i__1 = *n;
    for (ii = 1; ii <= i__1; ++ii) {
        i__ = *n + 1 - ii;
        l = i__ - 1;
        h__ = 0.;
        scale = 0.;
        if (l < 1) {
            goto L3;
        }
/* ********** */
        i__2 = l;
        for (k = 1; k <= i__2; ++k) {
/* L2: */
            scale = scale + (d__1 = ar_ref(i__, k), abs(d__1)) + (d__2 = 
                    ai_ref(i__, k), abs(d__2));
        }
        if (scale != 0.) {
            goto L4;
        }
        tau_ref(1, l) = 1.;
        tau_ref(2, l) = 0.;
L3:
        e[i__] = 0.;
        e2[i__] = 0.;
        goto L15;
L4:
        i__2 = l;
        for (k = 1; k <= i__2; ++k) {
            ar_ref(i__, k) = ar_ref(i__, k) / scale;
            ai_ref(i__, k) = ai_ref(i__, k) / scale;
            h__ = h__ + ar_ref(i__, k) * ar_ref(i__, k) + ai_ref(i__, k) * 
                    ai_ref(i__, k);
/* L5: */
        }
        e2[i__] = scale * scale * h__;
        g = sqrt(h__);
        e[i__] = scale * g;
        i__2 = ar_subscr(i__, l);
        i__3 = ai_subscr(i__, l);
        z__1.r = ar[i__2], z__1.i = ai[i__3];
        f = z_abs(&z__1);
/* ******** */
        if (f == 0.) {
            goto L6;
        }
        tau_ref(1, l) = (ai_ref(i__, l) * tau_ref(2, i__) - ar_ref(i__, l) * 
                tau_ref(1, i__)) / f;
        si = (ar_ref(i__, l) * tau_ref(2, i__) + ai_ref(i__, l) * tau_ref(1, 
                i__)) / f;
        h__ += f * g;
        g = g / f + 1.;
        ar_ref(i__, l) = g * ar_ref(i__, l);
        ai_ref(i__, l) = g * ai_ref(i__, l);
        if (l == 1) {
            goto L13;
        }
        goto L7;
L6:
        tau_ref(1, l) = -tau_ref(1, i__);
        si = tau_ref(2, i__);
        ar_ref(i__, l) = g;
L7:
        f = 0.;
        i__2 = l;
        for (j = 1; j <= i__2; ++j) {
            g = 0.;
            gi = 0.;
/* ********** */
            i__3 = j;
            for (k = 1; k <= i__3; ++k) {
                g = g + ar_ref(j, k) * ar_ref(i__, k) + ai_ref(j, k) * ai_ref(
                        i__, k);
                gi = gi - ar_ref(j, k) * ai_ref(i__, k) + ai_ref(j, k) * 
                        ar_ref(i__, k);
/* L8: */
            }
            jp1 = j + 1;
            if (l < jp1) {
                goto L10;
            }
            i__3 = l;
            for (k = jp1; k <= i__3; ++k) {
                g = g + ar_ref(k, j) * ar_ref(i__, k) - ai_ref(k, j) * ai_ref(
                        i__, k);
                gi = gi - ar_ref(k, j) * ai_ref(i__, k) - ai_ref(k, j) * 
                        ar_ref(i__, k);
/* L9: */
            }
/* ********* */
L10:
            e[j] = g / h__;
            tau_ref(2, j) = gi / h__;
            f = f + e[j] * ar_ref(i__, j) - tau_ref(2, j) * ai_ref(i__, j);
/* L11: */
        }
        hh = f / (h__ + h__);
/* ********** */
        i__2 = l;
        for (j = 1; j <= i__2; ++j) {
            f = ar_ref(i__, j);
            g = e[j] - hh * f;
            e[j] = g;
            fi = -ai_ref(i__, j);
            gi = tau_ref(2, j) - hh * fi;
            tau_ref(2, j) = -gi;
            i__3 = j;
            for (k = 1; k <= i__3; ++k) {
                ar_ref(j, k) = ar_ref(j, k) - f * e[k] - g * ar_ref(i__, k) + 
                        fi * tau_ref(2, k) + gi * ai_ref(i__, k);
                ai_ref(j, k) = ai_ref(j, k) - f * tau_ref(2, k) - g * ai_ref(
                        i__, k) - fi * e[k] - gi * ar_ref(i__, k);
/* L12: */
            }
        }
L13:
        i__3 = l;
        for (k = 1; k <= i__3; ++k) {
            ar_ref(i__, k) = scale * ar_ref(i__, k);
            ai_ref(i__, k) = scale * ai_ref(i__, k);
/* L14: */
        }
        tau_ref(2, l) = -si;
L15:
        hh = d__[i__];
        d__[i__] = ar_ref(i__, i__);
        ar_ref(i__, i__) = hh;
        ai_ref(i__, i__) = scale * sqrt(h__);
/* L16: */
    }
    return 0;
} /* aer7d_c */

#undef tau_ref
#undef ar_ref
#undef ar_subscr
#undef ai_ref
#undef ai_subscr
